<?php


define("_TAD_RSS_PIC_URL",XOOPS_URL.'/uploads/tad_rss');
define("_TAD_RSS_PIC_PATH",XOOPS_ROOT_PATH.'/uploads/tad_rss');
define("_TAD_RSS_THUMB_PIC_URL",XOOPS_URL.'/uploads/tad_rss/thumbs');
define("_TAD_RSS_THUMB_PIC_PATH",XOOPS_ROOT_PATH.'/uploads/tad_rss/thumbs');

//顯示圖片
function get_show_pic($href,$mode='thumb'){

  $imgname=mk_pic_name_from_url($href);
  if($mode=='thumb'){
    $pic=_TAD_RSS_THUMB_PIC_URL."/{$imgname}.jpg";
    $pic_path=_TAD_RSS_THUMB_PIC_PATH."/{$imgname}.jpg";
    $empty=XOOPS_URL."/modules/tad_rss/images/pic_thumb.png";
  }else{
    $pic=_TAD_RSS_PIC_URL."/{$imgname}.jpg";
    $pic_path=_TAD_RSS_PIC_PATH."/{$imgname}.jpg";
    $empty=XOOPS_URL."/modules/tad_rss/images/pic_big.png";
  }
  if(file_exists($pic_path)){
    return $pic;
  }else{
    get_pic($href);
    return $empty;
  }
}


function mk_pic_name_from_url($url=""){
  $imgname=str_replace("http://","",$url);
  $imgname=str_replace(".","",$imgname);
  $imgname=str_replace("?","",$imgname);
  $imgname=str_replace("&","",$imgname);
  $imgname=str_replace("#","",$imgname);
  $imgname=str_replace("=","",$imgname);
  $imgname=str_replace("~","",$imgname);
  $imgname=str_replace("/","_",$imgname);
  return $imgname;
}

//遠端擷取圖片
function get_pic($href=''){
  $imgname=mk_pic_name_from_url($href);

	copyemz("http://capture.heartrails.com/400x300/border?{$href}",_TAD_RSS_PIC_PATH."/{$imgname}.jpg");
	if(filesize(_TAD_RSS_PIC_PATH."/{$imgname}.jpg")==9805){
    unlink(_TAD_RSS_PIC_PATH."/{$imgname}.jpg");
  }else{
    thumbnail(_TAD_RSS_PIC_PATH."/{$imgname}.jpg",_TAD_RSS_THUMB_PIC_PATH."/{$imgname}.jpg");
	}
}


//複製檔案
function copyemz($file1,$file2){
  $contentx =@vita_get_url_content($file1);
  $openedfile = fopen($file2, "w");
  fwrite($openedfile, $contentx);
  fclose($openedfile);
  if ($contentx === FALSE) {
    $status=false;
  }else $status=true;

  return $status;
}

//遠端取得資料
function vita_get_url_content($url) {
  if(function_exists('file_get_contents')) {
    $file_contents = file_get_contents($url);
  } else {
    $ch = curl_init();
    $timeout = 5;
    curl_setopt ($ch, CURLOPT_URL, $url);
    curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
    $file_contents = curl_exec($ch);
    curl_close($ch);
  }
  return $file_contents;
}

//做縮圖
function thumbnail($filename="",$thumb_name="",$type="image/jpeg",$width="120"){

	ini_set('memory_limit', '50M');
	// Get new sizes
	list($old_width, $old_height) = getimagesize($filename);

	$percent=($old_width>$old_height)?round($width/$old_width,2):round($width/$old_height,2);

	$newwidth = ($old_width>$old_height)?$width:$old_width * $percent;
	$newheight = ($old_width>$old_height)?$old_height * $percent:$width;

	// Load
	$thumb = imagecreatetruecolor($newwidth, $newheight);
	if($type=="image/jpeg" or $type=="image/jpg" or $type=="image/pjpg" or $type=="image/pjpeg"){
		$source = imagecreatefromjpeg($filename);
		$type="image/jpeg";
	}elseif($type=="image/png"){
		$source = imagecreatefrompng($filename);
		$type="image/png";
	}elseif($type=="image/gif"){
		$source = imagecreatefromgif($filename);
		$type="image/gif";
	}

	// Resize
	imagecopyresampled($thumb, $source, 0, 0, 0, 0, $newwidth, $newheight, $old_width, $old_height);

  header("Content-type: image/png");
	imagepng($thumb,$thumb_name);

	return;
	exit;
}

//取得第一則消息的圖片
function get_first_rss_by_simplepie($url="",$width=170){

	require_once(XOOPS_ROOT_PATH.'/modules/tad_rss/class/simplepie/simplepie.inc');
	$feed = new SimplePie();
	$feed->set_output_encoding(_CHARSET);
	$feed->set_feed_url($url);
	$feed->set_cache_location(XOOPS_ROOT_PATH."/uploads/simplepie_cache");
	$feed->init();
	$feed->handle_content_type();

	$height=round($width/2,0);

	foreach ($feed->get_items(0, 1) as $item) {
		$href = $item->get_permalink();
		$title = $item->get_title();
		$date= $item->get_date("m/d");
		$img=get_show_pic($href,'big');
		$pic= "<a href='{$href}'><img title='[{$date}]{$title}' src='$img' alt='[{$date}]{$title}' width='{$width}' /></a>";
	}

	return $pic;
}

?>
