<?php
//  ------------------------------------------------------------------------ //
// 本模組由 tad 製作
// 製作日期：2012-03-12
// $Id:$
// ------------------------------------------------------------------------- //

/*-----------引入檔案區--------------*/
include_once "header_admin.php";

/*-----------function區--------------*/

//模組整合界面
function plugin_setup($class_sn=""){
	global $xoopsDB,$xoopsUser;
	
  if(empty($class_sn)){
    $class_sn=get_current_class();
  }

  $main="<table id='tbl'>
  <tr><th>模組目錄</th><th>選單文字</th><th>操作</th></tr>";
  
  $dir = XOOPS_ROOT_PATH."/modules/tad_class/plugin/";

  if (is_dir($dir)) {
      if ($dh = opendir($dir)) {
          while (($file = readdir($dh)) !== false) {
            if(substr($file,0,1)=='.')continue;
              if(is_dir($dir.$file)){
                $main.=get_plugin($file,$class_sn);
              }else{
                $main.="<tr><td colspan=3>{$file} 不是一個合法目錄</td></tr>";
              }
          }
          closedir($dh);
      }
  }

  $main.="</table>";

	//raised,corners,inset
	$main=div_3d("模組整合",$main,"corners");

  return $main;
}


function get_plugin($dirname="",$class_sn=""){
  global $xoopsDB;
  if(empty($class_sn)){
    $class_sn=get_current_class();
  }
  $class=get_tad_class($class_sn);
  $sql = "select * from ".$xoopsDB->prefix("modules")." where `dirname`='$dirname'";
	$result = $xoopsDB->query($sql) or redirect_header($_SERVER['PHP_SELF'],3, mysql_error());
	$data=$xoopsDB->fetchArray($result);
	
  if(!empty($data)){
    $sql = "select * from ".$xoopsDB->prefix("tad_class_plugin")." where `mid`='{$data['mid']}' and class_sn='$class_sn'";
  	$result = $xoopsDB->query($sql) or redirect_header($_SERVER['PHP_SELF'],3, mysql_error());
  	$plugin=$xoopsDB->fetchArray($result);
  	
  	$title=empty($plugin['plugin_sn'])?$class['class_name'].$data['name']:$plugin['plugin_title'];

    if(empty($plugin['plugin_sn'])){
        $main="
        <form action='plugin.php' method='post'>
        <tr>
        <td>$dirname</td>
        <td><input type='text' name='title' value='{$title}'></td>
        <td colspan=4>
        <input type='hidden' name='op' value='link_plugin'>
        <input type='hidden' name='class_sn' value='$class_sn'>
        <input type='hidden' name='dirname' value='$dirname'>
        <input type='hidden' name='mid' value='{$data['mid']}'>
        <input type='submit' value='整合 {$dirname} 外掛'></td>
        </tr>
        </form>";
    }else{
        $main="
        <form action='plugin.php' method='post'>
        <tr>
        <td>$dirname</td>
        <td><input type='text' name='title' value='{$title}'></td>
        <td>
        <input type='hidden' name='op' value='update_link_plugin'>
        <input type='hidden' name='plugin_sn' value='{$plugin['plugin_sn']}'>
        <input type='submit' value='更新設定'>
        <input type='button' value='解除整合' onClick=\"location.href='plugin.php?op=uninstall&mid=$mid&plugin_sn={$plugin['plugin_sn']}'\">
        </td>
        </tr>
        </form>";
    }
  }
  
  return $main;
}


//取得模組編號
function get_mod_id($mod_name=''){
  $modhandler = &xoops_gethandler('module');
  $xoopsModule = &$modhandler->getByDirname($mod_name);
  $mod_id=$xoopsModule->getVar('mid');
  return $mod_id;
}



//以流水號取得某筆tad_class_plugin資料
function get_tad_class_plugin($plugin_sn=""){
	global $xoopsDB;
	if(empty($plugin_sn))return;
	$sql = "select * from ".$xoopsDB->prefix("tad_class_plugin")." where plugin_sn='$plugin_sn'";
	$result = $xoopsDB->query($sql) or redirect_header($_SERVER['PHP_SELF'],3, mysql_error());
	$data=$xoopsDB->fetchArray($result);
	return $data;
}

//刪除tad_class_plugin某筆資料資料
function uninstall($plugin_sn="",$mid=""){
	global $xoopsDB;
/*
  $sql="update ".$xoopsDB->prefix("modules")." set `weight` = 1 where `mid`='{$mid}'";
	$xoopsDB->queryF($sql) or redirect_header($_SERVER['PHP_SELF'],3, mysql_error());
*/
	$sql = "delete from ".$xoopsDB->prefix("tad_class_plugin")." where plugin_sn='$plugin_sn'";
	$xoopsDB->queryF($sql) or redirect_header($_SERVER['PHP_SELF'],3, mysql_error());
}


//進行整合
function link_plugin($mid="",$class_sn="",$title="",$dirname=""){
  global $xoopsDB;
  
  include_once("../plugin/{$dirname}/func.php");
  $col=call_user_func("add_cate_{$dirname}", $title);
  
  //先隱藏該模組，然後設定分類
  /*
  $sql="update ".$xoopsDB->prefix("modules")." set `weight` = 0 where `mid`='{$mid}'";
	$xoopsDB->queryF($sql) or redirect_header($_SERVER['PHP_SELF'],3, mysql_error());
  */
  
  //新增外掛
	$sql = "insert into ".$xoopsDB->prefix("tad_class_plugin")."
	(`mid`, `dirname` , `class_sn` , `plugin_title` , `plugin_enable` , `col_name` , `col_sn` , `page`)
	values('{$mid}' , '{$dirname}' , '{$class_sn}' , '{$title}' , '1' ,'{$col['name']}','{$col['sn']}' ,'{$col['page']}')";
	$xoopsDB->queryF($sql) or redirect_header($_SERVER['PHP_SELF'],3, mysql_error());

	//取得最後新增資料的流水編號
	$plugin_sn=$xoopsDB->getInsertId();

}


//更新tad_class_plugin某一筆資料
function update_link_plugin($plugin_sn=""){
	global $xoopsDB,$xoopsUser;


	$myts =& MyTextSanitizer::getInstance();
	$_POST['title']=$myts->addSlashes($_POST['title']);


	$sql = "update ".$xoopsDB->prefix("tad_class_plugin")." set
	 `plugin_title` = '{$_POST['title']}'
	where plugin_sn='$plugin_sn'";
	$xoopsDB->queryF($sql) or redirect_header($_SERVER['PHP_SELF'],3, mysql_error());
	return $plugin_sn;
}

/*-----------執行動作判斷區----------*/
$op = (!isset($_REQUEST['op']))? "":$_REQUEST['op'];
$stu_sn=empty($_REQUEST['stu_sn'])?"":intval($_REQUEST['stu_sn']);
$class_sn=empty($_REQUEST['class_sn'])?"":intval($_REQUEST['class_sn']);
$mid=empty($_REQUEST['mid'])?"":intval($_REQUEST['mid']);
$plugin_sn=empty($_REQUEST['plugin_sn'])?"":intval($_REQUEST['plugin_sn']);

switch($op){

  //替換資料
  case "replace_tad_class_plugin":
  replace_tad_class_plugin();
  header("location: {$_SERVER['PHP_SELF']}");
  break;


  //更新資料
  case "update_link_plugin":
  update_link_plugin($plugin_sn);
  header("location: {$_SERVER['PHP_SELF']}");
  break;


  //刪除資料
  case "uninstall":
  uninstall($plugin_sn,$mid);
  header("location: {$_SERVER['PHP_SELF']}");
  break;


  case "link_plugin":
  link_plugin($mid,$class_sn,$_POST['title'],$_POST['dirname']);
  header('location:plugin.php');
  break;

  //預設動作
  default:
  $main=plugin_setup($class_sn);
  break;
}

/*-----------秀出結果區--------------*/
module_admin_footer($main,0);

?>